Bug 707613 (dcm4che-test) - Review Request: dcm4che-test - Test images for dcm4che2
Summary: Review Request: dcm4che-test - Test images for dcm4che2
Keywords:
Status: CLOSED ERRATA
Alias: dcm4che-test
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mario Ceresa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-medical
TreeView+ depends on / blocked
 
Reported: 2011-05-25 14:09 UTC by Ankur Sinha (FranciscoD)
Modified: 2011-06-07 04:39 UTC (History)
4 users (show)

Fixed In Version: dcm4che-test-2.6-0.1.fc15.20110530svn15516
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-06-07 04:39:29 UTC
Type: ---
mrceresa: fedora-review+
petersen: fedora-cvs+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2011-05-25 14:09:25 UTC
Spec URL: http://ankursinha.fedorapeople.org/dcm4che2-test/dcm4che2-test.spec
SRPM URL: http://ankursinha.fedorapeople.org/dcm4che2-test/dcm4che2-test-2.6-1.fc15.src.rpm
Description: Test images for dcm4che2

The srpm is 70M, still uploading :)

Comment 1 Mario Ceresa 2011-05-25 17:40:06 UTC
I'll review it!
Mario

Comment 2 Mario Ceresa 2011-05-26 08:21:24 UTC
Hi Ankur! 

koji build works fine: 
http://koji.fedoraproject.org/koji/taskinfo?taskID=3093194

So far I found the following problems:

- Is it possible to add a group? (Maybe some of the groups you recently created for this purpose?)
- if it is taken from a svn checkout, shouldn't it be named accordingly? (http://fedoraproject.org/wiki/Packaging:NamingGuidelines). Something like dcm4chee-test-2.6-YYYYMMDDsvn<rev>?

And a thing I don't understand:

- In the add_to_maven section, what are the project_group_id and project_artifact_id? 

Please comment on those issues and I'll make a formal review.

Thanks

Mario

Comment 3 Ankur Sinha (FranciscoD) 2011-05-26 13:01:05 UTC
(In reply to comment #2)
> Hi Ankur! 
> 
> koji build works fine: 
> http://koji.fedoraproject.org/koji/taskinfo?taskID=3093194
> 
> So far I found the following problems:
> 
> - Is it possible to add a group? (Maybe some of the groups you recently created
> for this purpose?)

I haven't added groups to comps yet. I didn't want to create empty ones :$. 

Anyway, the GROUPS tag here isn't the one that we add in comps (yum groups). It's one of those present in /usr/share/doc/rpm-4.9.0/GROUPS. Not sure if any of them fit in for this package though :/

> - if it is taken from a svn checkout, shouldn't it be named accordingly?
> (http://fedoraproject.org/wiki/Packaging:NamingGuidelines). Something like
> dcm4chee-test-2.6-YYYYMMDDsvn<rev>?
> 

It is a svn checkout, but only because there isn't a release for this. It's tagged as version 2.6, so I'm not sure if I need to use the svn or the version.

> And a thing I don't understand:
> 
> - In the add_to_maven section, what are the project_group_id and
> project_artifact_id? 
> 

I've corrected this part in the spec. 

> Please comment on those issues and I'll make a formal review.
> 
> Thanks
> 
> Mario

http://ankursinha.fedorapeople.org/dcm4che2-test/dcm4che2-test-2.6-1.fc15.src.rpm

http://ankursinha.fedorapeople.org/dcm4che2-test/dcm4che2-test.spec

* Thu May 26 2011 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 2.6-1
- Correct add to maven depmap command
- initial rpm build

Thanks!
Ankur

Comment 4 Ankur Sinha (FranciscoD) 2011-05-27 07:33:28 UTC
Hi Mario,

Could you please wait a day or two before the review. Even though the package builds properly, I think there's something wrong with the placement of the pom files etc., which is essential to be able to build packages that depend on this one (such as dcm4che). I've mailed upstream requesting them to detail out the build method for the test-images. I expect a reply soon, and will try to replicate their method in the spec. 

Thanks,
Ankur

Comment 5 Mario Ceresa 2011-05-27 09:22:00 UTC
Sure Ankur!

I'll stay tuned then...

Best,

Mario

Comment 6 Ankur Sinha (FranciscoD) 2011-05-27 13:10:52 UTC
Hi Mario! 

With some help from the fedora-java folks, I managed to correct the package. Please find the latest at:

http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test.spec

http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test-2.6-1.fc15.src.rpm

Even dcm4che accepts it as a dep etc., which gives me confidence that the packaging is ok :)

Thanks,
Ankur

Comment 7 Mario Ceresa 2011-05-28 19:16:18 UTC
Hi Ankur!

Here it goes the review: +/!/- mean ok/bad/does not apply

! MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

rpmlint in not silent:

[mario@shadow rpmbuild]$ rpmlint SRPMS/dcm4che-test-2.6-1.fc15.src.rpm RPMS/noarch/dcm4che-test-2.6-1.fc15.noarch.rpm RPMS/noarch/dcm4che-test-javadoc-2.6-1.fc15.noarch.rpm
dcm4che-test.src: W: invalid-license GPLv2.0
dcm4che-test.src: W: invalid-license LGPLv2.1
dcm4che-test.src: W: invalid-url Source0: dcm4che2-test-2.6.tar.gz
dcm4che-test.noarch: W: invalid-license GPLv2.0
dcm4che-test.noarch: W: invalid-license LGPLv2.1
dcm4che-test.noarch: W: no-documentation
dcm4che-test.noarch: W: non-conffile-in-etc /etc/maven/fragments/dcm4che-test
dcm4che-test-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
dcm4che-test-javadoc.noarch: W: invalid-license GPLv2.0
dcm4che-test-javadoc.noarch: W: invalid-license LGPLv2.1
dcm4che-test-javadoc.noarch: E: script-without-shebang /usr/share/javadoc/dcm4che-test/apidocs/javadoc.sh


 Please consider:
- use recognized license names (rpmlint -i will give you the names) 
- mark /etc/maven/fragments/dcm4che-test as a conf-file, if you feel it correct

! MUST: The package must be named according to the Package Naming Guidelines .

Why do you not call the package dcm4che2-test instead of dcm4che-test? 

Moreover, as it is a svn checkout, I think it should be named accordingly. However I understand that this is tagged as a stable release, so it's your decision.

+ MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
+ MUST: The package must meet the Packaging Guidelines .
+ MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

! MUST: The License field in the package spec file must match the actual license.

Please use a name recognized by rpmlint

- MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
+ MUST: The spec file must be written in American English. 
+ MUST: The spec file for the package MUST be legible. 

! MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

They differs:

[mario@shadow dcm4che2]$ svn co https://dcm4che.svn.sourceforge.net/svnroot/dcm4che/dcm4che2-test/tags/dcm4che2-test-2.6
[mario@shadow dcm4che2]$ tar -cvzf dcm4che2-test-2.6.tar.gz dcm4che2-test-2.6/
[mario@shadow dcm4che2]$ md5sum dcm4che2-test-2.6.tar.gz 
9023b1143b1089fbaaedb752dfb8139a  dcm4che2-test-2.6.tar.gz

[mario@shadow dcm4che2]$ md5sum /home/mario/rpmbuild/SOURCES/dcm4che2-test-2.6.tar.gz 
07e709c479df9301324053e2d605309f  /home/mario/rpmbuild/SOURCES/dcm4che2-test-2.6.tar.gz


+ MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. 

The package successfully builds in koji:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3098038

- MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. 
+ MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
- MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
- MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
+ MUST: Packages must NOT bundle copies of system libraries.
- MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
+ MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
+ MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
+ MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. 
+ MUST: Each package must consistently use macros. 
+ MUST: The package must contain code, or permissable content. 
+ MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
+ MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. 
- MUST: Header files must be in a -devel package. 
- MUST: Static libraries must be in a -static package.
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
- MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} 
- MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
- MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
+ MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
+ MUST: All filenames in rpm packages must be valid UTF-8. 
+ MUST: The package follows the Java Packaging guidelines (at least as far as I got them :) )

Please fix all the reported issues and I'll approve the package.

Best,

Mario

Comment 8 Peter Lemenkov 2011-05-29 15:21:48 UTC
(In reply to comment #2)
> Hi Ankur! 

> - if it is taken from a svn checkout, shouldn't it be named accordingly?
> (http://fedoraproject.org/wiki/Packaging:NamingGuidelines). Something like
> dcm4chee-test-2.6-YYYYMMDDsvn<rev>?

Correct. The versioning scheme is wrong. It must indicate that it was built feom SCM snapshot. The %{release} field should contain something like this:

0.<rpm_release>.YYYYMMDDsvn%{svn_rev}

Note the leading zero before actual rpm release number.

Comment 9 Ankur Sinha (FranciscoD) 2011-05-30 04:55:33 UTC
(In reply to comment #7)
> Hi Ankur!
> 
> Here it goes the review: +/!/- mean ok/bad/does not apply
> 
> ! MUST: rpmlint must be run on the source rpm and all binary rpms the build
> produces. The output should be posted in the review.
> 
> rpmlint in not silent:
> 
> [mario@shadow rpmbuild]$ rpmlint SRPMS/dcm4che-test-2.6-1.fc15.src.rpm
> RPMS/noarch/dcm4che-test-2.6-1.fc15.noarch.rpm
> RPMS/noarch/dcm4che-test-javadoc-2.6-1.fc15.noarch.rpm
> dcm4che-test.src: W: invalid-license GPLv2.0
> dcm4che-test.src: W: invalid-license LGPLv2.1
> dcm4che-test.src: W: invalid-url Source0: dcm4che2-test-2.6.tar.gz
> dcm4che-test.noarch: W: invalid-license GPLv2.0
> dcm4che-test.noarch: W: invalid-license LGPLv2.1
> dcm4che-test.noarch: W: no-documentation
> dcm4che-test.noarch: W: non-conffile-in-etc /etc/maven/fragments/dcm4che-test
> dcm4che-test-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java
> docs, Java-docs, Avocados
> dcm4che-test-javadoc.noarch: W: invalid-license GPLv2.0
> dcm4che-test-javadoc.noarch: W: invalid-license LGPLv2.1
> dcm4che-test-javadoc.noarch: E: script-without-shebang
> /usr/share/javadoc/dcm4che-test/apidocs/javadoc.sh
> 
> 

>  Please consider:
> - use recognized license names (rpmlint -i will give you the names) 

Corrected.

> - mark /etc/maven/fragments/dcm4che-test as a conf-file, if you feel it correct

I checked up another java package spec. maven fragments are not marked as conf files it looks like. 

> 
> ! MUST: The package must be named according to the Package Naming Guidelines .
> 
> Why do you not call the package dcm4che2-test instead of dcm4che-test? 

the "2" in "dcm4che2" stands for versioning. It's not a lot of use including it in the name. dcm4che2-2.... is redundant IMO?

> 
> Moreover, as it is a svn checkout, I think it should be named accordingly.
> However I understand that this is tagged as a stable release, so it's your
> decision.
> 

Corrected. 

> + MUST: The spec file name must match the base package %{name}, in the format
> %{name}.spec unless your package has an exemption.
> + MUST: The package must meet the Packaging Guidelines .
> + MUST: The package must be licensed with a Fedora approved license and meet
> the Licensing Guidelines .
> 
> ! MUST: The License field in the package spec file must match the actual
> license.
> 
> Please use a name recognized by rpmlint
> 

Corrected.

> - MUST: If (and only if) the source package includes the text of the license(s)
> in its own file, then that file, containing the text of the license(s) for the
> package must be included in %doc.
> + MUST: The spec file must be written in American English. 
> + MUST: The spec file for the package MUST be legible. 
> 
> ! MUST: The sources used to build the package must match the upstream source,
> as provided in the spec URL. Reviewers should use md5sum for this task. If no
> upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.
> 
> They differs:
> 
> [mario@shadow dcm4che2]$ svn co
> https://dcm4che.svn.sourceforge.net/svnroot/dcm4che/dcm4che2-test/tags/dcm4che2-test-2.6
> [mario@shadow dcm4che2]$ tar -cvzf dcm4che2-test-2.6.tar.gz dcm4che2-test-2.6/
> [mario@shadow dcm4che2]$ md5sum dcm4che2-test-2.6.tar.gz 
> 9023b1143b1089fbaaedb752dfb8139a  dcm4che2-test-2.6.tar.gz
> 
> [mario@shadow dcm4che2]$ md5sum
> /home/mario/rpmbuild/SOURCES/dcm4che2-test-2.6.tar.gz 
> 07e709c479df9301324053e2d605309f 
> /home/mario/rpmbuild/SOURCES/dcm4che2-test-2.6.tar.gz
> 

I've done a fresh svn export and made the tar. This shouldn't happen now. 

> 
> + MUST: The package MUST successfully compile and build into binary rpms on at
> least one primary architecture. 
> 
> The package successfully builds in koji:
> http://koji.fedoraproject.org/koji/taskinfo?taskID=3098038
> 
> - MUST: If the package does not successfully compile, build or work on an
> architecture, then those architectures should be listed in the spec in
> ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
> bugzilla, describing the reason that the package does not compile/build/work on
> that architecture. The bug number MUST be placed in a comment, next to the
> corresponding ExcludeArch line. 
> + MUST: All build dependencies must be listed in BuildRequires, except for any
> that are listed in the exceptions section of the Packaging Guidelines ;
> inclusion of those as BuildRequires is optional. Apply common sense.
> - MUST: The spec file MUST handle locales properly. This is done by using the
> %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
> - MUST: Every binary RPM package (or subpackage) which stores shared library
> files (not just symlinks) in any of the dynamic linker's default paths, must
> call ldconfig in %post and %postun. 
> + MUST: Packages must NOT bundle copies of system libraries.
> - MUST: If the package is designed to be relocatable, the packager must state
> this fact in the request for review, along with the rationalization for
> relocation of that specific package. Without this, use of Prefix: /usr is
> considered a blocker. 
> + MUST: A package must own all directories that it creates. If it does not
> create a directory that it uses, then it should require a package which does
> create that directory. 
> + MUST: A Fedora package must not list a file more than once in the spec file's
> %files listings. (Notable exception: license texts in specific situations)
> + MUST: Permissions on files must be set properly. Executables should be set
> with executable permissions, for example. 
> + MUST: Each package must consistently use macros. 
> + MUST: The package must contain code, or permissable content. 
> + MUST: Large documentation files must go in a -doc subpackage. (The definition
> of large is left up to the packager's best judgement, but is not restricted to
> size. Large can refer to either size or quantity). 
> + MUST: If a package includes something as %doc, it must not affect the runtime
> of the application. To summarize: If it is in %doc, the program must run
> properly if it is not present. 
> - MUST: Header files must be in a -devel package. 
> - MUST: Static libraries must be in a -static package.
> - MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
> then library files that end in .so (without suffix) must go in a -devel
> package.
> - MUST: In the vast majority of cases, devel packages must require the base
> package using a fully versioned dependency: Requires: %{name}%{?_isa} =
> %{version}-%{release} 
> - MUST: Packages must NOT contain any .la libtool archives, these must be
> removed in the spec if they are built.
> - MUST: Packages containing GUI applications must include a %{name}.desktop
> file, and that file must be properly installed with desktop-file-install in the
> %install section. If you feel that your packaged GUI application does not need
> a .desktop file, you must put a comment in the spec file with your explanation. 
> + MUST: Packages must not own files or directories already owned by other
> packages. The rule of thumb here is that the first package to be installed
> should own the files or directories that other packages may rely upon. This
> means, for example, that no package in Fedora should ever share ownership with
> any of the files or directories owned by the filesystem or man package. If you
> feel that you have a good reason to own a file or directory that another
> package owns, then please present that at package review time. 
> + MUST: All filenames in rpm packages must be valid UTF-8. 
> + MUST: The package follows the Java Packaging guidelines (at least as far as I
> got them :) )
> 
> Please fix all the reported issues and I'll approve the package.
> 
> Best,
> 
> Mario

I think I've fixed them all :)

New spec, srpm:

http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test.spec

http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test-2.6-0.1.fc15.20110530svn15516.src.rpm

Thanks!!

Ankur

Comment 10 Mario Ceresa 2011-05-30 07:41:40 UTC
Great work Ankur!

+ koji can correctly build the package
http://koji.fedoraproject.org/koji/taskinfo?taskID=3099815

! rpmlint is *not* silent

[mario@shadow koji]$ rpmlint *.rpm
dcm4che-test.noarch: W: no-documentation

this is ok: we have a separate package for documentation

dcm4che-test.noarch: W: non-conffile-in-etc /etc/maven/fragments/dcm4che-test
dcm4che-test.src: W: invalid-url Source0: dcm4che2-test-2.6.tar.gz

this is ok, the package is taken from svn

dcm4che-test-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados

Harmless

dcm4che-test-javadoc.noarch: E: script-without-shebang /usr/share/javadoc/dcm4che-test/apidocs/javadoc.sh

just add the build root to the find line that you already put in the spec. This made the trick for me:
find $RPM_BUILD_ROOT%{_javadocdir}/%{name} -name "javadoc.sh" -exec chmod a-x '{}' \;

3 packages and 0 specfiles checked; 1 errors, 4 warnings.


! md5sum
Still md5sums are different:
477961623e091b2d5f7119f2a69fc1ff  dcm4che2-test-svn-2.6.tar.gz
381ce690ad2c5deff411f79eeea9c1d9  dcm4che2-test-2.6-srpm.tar.gz

Thi is strange, I obtain two different tarballs:

-rw-rw-r--. 1 mario mario 36713364 May 29 21:25 dcm4che2-test-2.6-srpm.tar.gz
-rw-rw-r--. 1 mario mario 36706444 May 30 08:51 dcm4che2-test-svn-2.6.tar.gz

however, after extracting, diff shows no differences:

diff -r dcm4che2-test-2.6-srpm/ dcm4che2-test-svn-2.6/

*puzzled*

So, the package is basically ok: if you don't mind, please repost the srpm with the changed find line so that the last error in rpmlint disappears.

In the meantime I'll investigate why md5sum outputs differ. It is probably nothing important or a mistake on my side because the tarballs look identical with diff.

Best

Mario

Comment 11 Ankur Sinha (FranciscoD) 2011-05-30 09:18:12 UTC
Hi Mario,

I've corrected the find command. 

I have no clue why the md5sum is coming different. 

Could it be different versions of tar?

[ankur@ankur SRPMS]$ rpm -q tar
tar-1.25-6.fc15.x86_64

Fresh spec, srpm:

http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test.spec
http://ankursinha.fedorapeople.org/dcm4che-test/dcm4che-test-2.6-0.1.fc15.20110530svn15516.src.rpm

Thanks!!
Ankur

Comment 12 Mario Ceresa 2011-05-30 09:26:13 UTC
No, do not worry: Peter just explained me that md5sum is not so useful in case of tarballs generated by svn checkout. They are identical when I checked with diff, so this is ok.

The package is APPROVED.

Congratulations Ankur!

Comment 13 Ankur Sinha (FranciscoD) 2011-05-30 09:35:07 UTC
Thanks Mario, Peter!!!

Comment 14 Ankur Sinha (FranciscoD) 2011-05-30 09:37:38 UTC
New Package SCM Request
=======================
Package Name: dcm4che-test
Short Description: Test images for dcm4che2
Owners: ankursinha
Branches: f15 f14
InitialCC: susmit mrceresa

Comment 15 Jens Petersen 2011-05-31 07:01:18 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2011-05-31 12:16:50 UTC
dcm4che-test-2.6-0.1.fc15.20110530svn15516 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/dcm4che-test-2.6-0.1.fc15.20110530svn15516

Comment 17 Fedora Update System 2011-06-02 19:08:04 UTC
dcm4che-test-2.6-0.1.fc15.20110530svn15516 has been pushed to the Fedora 15 testing repository.

Comment 18 Fedora Update System 2011-06-07 04:39:25 UTC
dcm4che-test-2.6-0.1.fc15.20110530svn15516 has been pushed to the Fedora 15 stable repository.


Note You need to log in before you can comment on or make changes to this bug.